VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8280
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   8280
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MAX As Single = 200

Private Sub Form_Paint()
    DrawWavedText Me, "This example shows how to draw vertical text that follows a curved path", 120, 2 * MAX, False, False
    DrawWavedText Me, "This example shows how to draw vertical text that follows a curved path", 120, 6 * MAX, False, True
    DrawWavedText Me, "This example shows how to draw vertical text that follows a curved path", 120, 10 * MAX, True, True
End Sub

Private Sub DrawWavedText(ByVal obj As Object, ByVal txt As String, ByVal x0 As Single, ByVal y0 As Single, Optional ByVal draw_above As Boolean, Optional ByVal draw_curve As Boolean = False)
Dim i As Integer
Dim ch As String
Dim y_offset As Single
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single

    If draw_above Then
        y_offset = -obj.TextHeight("X")
    Else
        y_offset = 0
    End If

    x1 = x0
    y1 = F(x1) + y0
    x2 = x1
    y2 = y1
    For i = 1 To Len(txt)
        ' Draw the next character.
        obj.CurrentX = x2
        obj.CurrentY = y2 + y_offset
        ch = Mid$(txt, i, 1)
        obj.Print ch;

        ' Draw the line on the curve if desired.
        If draw_curve Then
            obj.Line (x1, y1)-(x2, y2)
        End If

        ' Move to the next point.
        x1 = x2
        y1 = y2
        x2 = x2 + obj.TextWidth(ch)
        y2 = F(x2) + y0
    Next i
End Sub

Private Function F(ByVal x As Single) As Single
    F = MAX * Sin(x / 250)
End Function
